import { Dictionary } from "../../fable-library.4.5.0/MutableMap.js";
import { structuralHash, equals } from "../../fable-library.4.5.0/Util.js";
import { class_type } from "../../fable-library.4.5.0/Reflection.js";
import { getItemFromDict } from "../../fable-library.4.5.0/MapUtil.js";
import { contains } from "../../fable-library.4.5.0/Array.js";
import { some } from "../../fable-library.4.5.0/Option.js";

export class ArraySet$1 {
    constructor() {
        this._array = [];
        this._set = (new Dictionary([], {
            Equals: equals,
            GetHashCode: structuralHash,
        }));
    }
}

export function ArraySet$1_$reflection(gen0) {
    return class_type("SourceMapSharp.ArraySet`1", [gen0], ArraySet$1);
}

export function ArraySet$1_$ctor() {
    return new ArraySet$1();
}

export function ArraySet$1__Size(_) {
    return _._set.size;
}

export function ArraySet$1__Has_2B595(_, aStr) {
    return _._set.has(aStr);
}

export function ArraySet$1__indexOf_2B595(_, aStr) {
    if (_._set.has(aStr)) {
        return getItemFromDict(_._set, aStr);
    }
    else {
        return void 0;
    }
}

export function ArraySet$1__Add_Z1FE5A521(_, aStr, aAllowDuplicates) {
    const isDuplicate = contains(aStr, _._array, {
        Equals: equals,
        GetHashCode: structuralHash,
    });
    const idx = _._set.size | 0;
    if (!isDuplicate ? true : aAllowDuplicates) {
        void (_._array.push(aStr));
    }
    if (!isDuplicate) {
        _._set.set(aStr, idx);
    }
}

export function ArraySet$1__At_Z524259A4(_, aIdx) {
    if ((aIdx >= 0) && (aIdx < _._array.length)) {
        return some(_._array[aIdx]);
    }
    else {
        return void 0;
    }
}

export function ArraySet$1__ToArray(_) {
    return _._array;
}

export function ArraySet$1_fromArray_Z76B293CC(aArray, allowDuplicates) {
    const s = ArraySet$1_$ctor();
    for (let idx = 0; idx <= (aArray.length - 1); idx++) {
        ArraySet$1__Add_Z1FE5A521(s, aArray[idx], allowDuplicates);
    }
    return s;
}

