import { toString, Exception } from "../../fable-library.4.5.0/Types.js";
import { class_type } from "../../fable-library.4.5.0/Reflection.js";
import { stringHash, int32ToString } from "../../fable-library.4.5.0/Util.js";
import { indexOf } from "../../fable-library.4.5.0/Array.js";
import { op_UnaryNegation_Int32 } from "../../fable-library.4.5.0/Int32.js";
import { StringBuilder__Append_244C7CD6, StringBuilder_$ctor } from "../../fable-library.4.5.0/System.Text.js";

export class VlqException extends Exception {
    constructor() {
        super();
    }
}

export function VlqException_$reflection() {
    return class_type("SourceMapSharp.VlqException", void 0, VlqException, class_type("System.Exception"));
}

export function VlqException_$ctor() {
    return new VlqException();
}

export function VlqException_$ctor_Z721C83C5(message) {
    VlqException_$ctor();
}

export function VlqException_$ctor_68CE3CA2(message, innerException) {
    VlqException_$ctor();
}

export const Base64_intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");

export function Base64_base64Encode(c) {
    if ((0 <= c) && (c < Base64_intToCharMap.length)) {
        return Base64_intToCharMap[c];
    }
    else {
        throw VlqException_$ctor_Z721C83C5("Must be between 0 and 63: " + int32ToString(c));
    }
}

export function Base64_base64Decode(c) {
    const index = indexOf(Base64_intToCharMap, c, void 0, void 0, {
        Equals: (x, y) => (x === y),
        GetHashCode: stringHash,
    }) | 0;
    if (index > -1) {
        return index | 0;
    }
    else {
        throw VlqException_$ctor_Z721C83C5("Not a valid base 64 digit: " + c);
    }
}

export class Base64Vlq {
    constructor() {
    }
}

export function Base64Vlq_$reflection() {
    return class_type("SourceMapSharp.Base64Vlq", void 0, Base64Vlq);
}

export function Base64Vlq_$ctor() {
    return new Base64Vlq();
}

export function Base64Vlq_get_VLQ_BASE_SHIFT() {
    return 5;
}

export function Base64Vlq_get_VLQ_BASE() {
    return 1 << Base64Vlq_get_VLQ_BASE_SHIFT();
}

export function Base64Vlq_get_VLQ_BASE_MASK() {
    return Base64Vlq_get_VLQ_BASE() - 1;
}

export function Base64Vlq_get_VLQ_CONTINUATION_BIT() {
    return Base64Vlq_get_VLQ_BASE();
}

function Base64Vlq_IsMappingSeparator_Z524259A4(ch) {
    if (ch === 44) {
        return true;
    }
    else {
        return ch === 59;
    }
}

function Base64Vlq_ToVLQSigned_Z524259A4(value) {
    if (value < 0) {
        return ((op_UnaryNegation_Int32(value) << 1) + 1) | 0;
    }
    else {
        return ((value << 1) + 0) | 0;
    }
}

function Base64Vlq_FromVLQSigned_Z524259A4(value) {
    let isNegative = (value & 1) === 1;
    let shifted = value >> 1;
    if (isNegative) {
        return op_UnaryNegation_Int32(shifted) | 0;
    }
    else {
        return shifted | 0;
    }
}

export function Base64Vlq_Encode_Z524259A4(number) {
    let encoded = StringBuilder_$ctor();
    let digit = 0;
    let vlq = Base64Vlq_ToVLQSigned_Z524259A4(number);
    let isZeroCase = number === 0;
    while ((vlq > 0) ? true : isZeroCase) {
        isZeroCase = false;
        digit = ((vlq & Base64Vlq_get_VLQ_BASE_MASK()) | 0);
        vlq = ((vlq >> Base64Vlq_get_VLQ_BASE_SHIFT()) | 0);
        if (vlq > 0) {
            digit = ((digit | Base64Vlq_get_VLQ_CONTINUATION_BIT()) | 0);
        }
        StringBuilder__Append_244C7CD6(encoded, Base64_base64Encode(digit));
    }
    return toString(encoded);
}

