import { MappingComparer_$ctor, Mapping, MappingIndex, compareByGeneratedPositionsInflated } from "./Util.fs.js";
import { class_type } from "../../fable-library.4.5.0/Reflection.js";
import { sortInPlace } from "../../fable-library.4.5.0/Array.js";

export function MappingListModule_generatedPositionAfter(mappingA, mappingB) {
    const lineA = mappingA.Generated.line | 0;
    const lineB = mappingB.Generated.line | 0;
    if ((lineB > lineA) ? true : ((lineB === lineA) && (mappingB.Generated.column >= mappingA.Generated.column))) {
        return true;
    }
    else {
        return compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
    }
}

export class MappingList {
    constructor() {
        this._array = [];
        this._sorted = true;
        this._last = (new Mapping(new MappingIndex(-1, 0), void 0, void 0, void 0));
    }
}

export function MappingList_$reflection() {
    return class_type("SourceMapSharp.MappingList", void 0, MappingList);
}

export function MappingList_$ctor() {
    return new MappingList();
}

export function MappingList__UnsortedForEach_Z7B352DA2(_, aCallback) {
    _._array.forEach(aCallback);
}

export function MappingList__Add_Z3411214C(_, aMapping) {
    if (MappingListModule_generatedPositionAfter(_._last, aMapping)) {
        _._last = aMapping;
        void (_._array.push(aMapping));
    }
    else {
        _._sorted = false;
        void (_._array.push(aMapping));
    }
}

export function MappingList__ToArray(_) {
    if (!_._sorted) {
        sortInPlace(_._array, MappingComparer_$ctor());
        _._sorted = true;
    }
    return _._array;
}

