import { printf, toFail } from "../../fable-library.4.5.0/String.js";
import { Dictionary } from "../../fable-library.4.5.0/MutableMap.js";
import { structuralHash, equals } from "../../fable-library.4.5.0/Util.js";
import { ArraySet$1__ToArray, ArraySet$1_fromArray_Z76B293CC } from "./ArraySet.fs.js";
import { defaultArg } from "../../fable-library.4.5.0/Option.js";
import { empty, map } from "../../fable-library.4.5.0/Seq.js";
import { computeSourceUrl } from "./Util.fs.js";
import { class_type } from "../../fable-library.4.5.0/Reflection.js";

export const SourceMapConsumer_version = 3;

export const SourceMapConsumer_GENERATED_ORDER = 1;

export const SourceMapConsumer_ORIGINAL_ORDER = 2;

export const SourceMapConsumer_GREATEST_LOWER_BOUND = 1;

export const SourceMapConsumer_LEAST_UPPER_BOUND = 2;

export class BasicSourceMapConsumer {
    constructor(sourceMap, sourceMapUrl) {
        if (SourceMapConsumer_version !== sourceMap.version) {
            toFail(printf("Unsupported version %i"))(sourceMap.version);
        }
        const _sourceLookupCache = new Dictionary([], {
            Equals: equals,
            GetHashCode: structuralHash,
        });
        const _names = ArraySet$1_fromArray_Z76B293CC(Array.from(sourceMap.names), true);
        const _sources = ArraySet$1_fromArray_Z76B293CC(Array.from(sourceMap.sources), true);
        const sourceRoot = defaultArg(sourceMap.sourceRoot, "");
        const sourceUrls = Array.from(map((s) => computeSourceUrl(sourceRoot, s, sourceMapUrl), sourceMap.sources));
        this._absoluteSources = ArraySet$1_fromArray_Z76B293CC(sourceUrls, true);
        const sourcesContent = defaultArg(sourceMap.sourcesContent, empty());
        this["_computedColumnSpans@"] = false;
        this["_mappingsPtr@"] = 0;
    }
}

export function BasicSourceMapConsumer_$reflection() {
    return class_type("SourceMapSharp.BasicSourceMapConsumer", void 0, BasicSourceMapConsumer);
}

export function BasicSourceMapConsumer_$ctor_79139D35(sourceMap, sourceMapUrl) {
    return new BasicSourceMapConsumer(sourceMap, sourceMapUrl);
}

export function BasicSourceMapConsumer__get__computedColumnSpans(__) {
    return __["_computedColumnSpans@"];
}

export function BasicSourceMapConsumer__get__mappingsPtr(__) {
    return __["_mappingsPtr@"];
}

export function BasicSourceMapConsumer__sources(_) {
    return ArraySet$1__ToArray(_._absoluteSources);
}

